<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/ncp/ncp_buffer.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d6/d92/ncp__buffer_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ncp_buffer.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d6/d92/ncp__buffer_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *    Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *    All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *    Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *    modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *    1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *       notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *    2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *       notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *       documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *    3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *       names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *       derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *    (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#ifndef NCP_FRAME_BUFFER_HPP_</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#define NCP_FRAME_BUFFER_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a>&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d5/d8c/message_8hpp.html">common/message.hpp</a>&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html">   41</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html">NcpFrameBuffer</a></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;{</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">   52</a></span>&#160;    <span class="keyword">typedef</span> void (*<a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a>)(<span class="keywordtype">void</span> *aContext, <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html">NcpFrameBuffer</a> *aNcpFrameBuffer);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ad20ceecdfd9130815f4f59a9192afeeb">NcpFrameBuffer</a>(uint8_t *aBuffer, uint16_t aBufferLength);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ae80bc3d36fafc2a41b13270f7ffe54c2">~NcpFrameBuffer</a>();</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab2380a440712abb615835172a0863bdf">Clear</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a69de51cb5b7132fa7d82270f3090f4dc">SetCallbacks</a>(<a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a> aEmptyBufferCallback, <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a> aNonEmptyBufferCallback, <span class="keywordtype">void</span> *aContext);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a5f8aef01dd5f6b673c2a16a7e0aece29">InFrameBegin</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a3987c8813a4aa3f7874b920736390e97">InFrameFeedData</a>(<span class="keyword">const</span> uint8_t *aDataBuffer, uint16_t aDataBufferLength);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af5fa8d69618ffb232ea0693f5622e948">InFrameFeedMessage</a>(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage);</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a46d59d1e7c71eff0d4cf9ea91b821ead">InFrameEnd</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a34a6141ff650ec07602b246fe3e65404">IsEmpty</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af7e6c123cca21c4ea9459c2a3ca350b6">OutFrameBegin</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#abf94a643cd4931c947e4682c6fa21a64">OutFrameHasEnded</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    uint8_t <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af8004f00f97e629cf5c5b0c6d695fcdc">OutFrameReadByte</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    uint16_t <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a4062341057541242068c5680c35f5a1c">OutFrameRead</a>(uint16_t aReadLength, uint8_t *aDataBuffer);</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab8a97ac52ae66b96155e6fb72cbd7e38">OutFrameRemove</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    uint16_t <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a8b7c96ec541408d307edf2c069ef208c">OutFrameGetLength</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    <span class="comment">/*</span></div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;<span class="comment">     * NcpFrameBuffer Implementation</span></div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="comment">     * -----------------------------</span></div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="comment">     * NcpFrameBuffer internally stores a frame as a sequence of data segments. The data segments are stored in the</span></div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="comment">     * the main buffer `mBuffer`. mBuffer is utilized as a circular buffer.</span></div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="comment">     * Messages (which are added using `InFrameFeedMessaged()`) are not copied in the `mBuffer` but instead are</span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="comment">     * enqueued in a message queue `mMessageQueue`.</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;<span class="comment">     * The data segments include a header before the data portion. The header is 2 bytes long is formated as follows</span></div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;<span class="comment">     *    Bit 0-13: Give the length of the data segment (max segment len is 2^14 = 16,384 bytes).</span></div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;<span class="comment">     *    Bit 14:   Flag bit set to indicate that this segment has an associated `Message` (appended to its end).</span></div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;<span class="comment">     *    Bit 15:   Flag bit set to indicate that this segment defines the start of a new frame.</span></div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;<span class="comment">     *        Bit  15         Bit 14            Bits: 0 - 13</span></div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;<span class="comment">     *    +--------------+--------------+--------------------------------------------------------+</span></div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;<span class="comment">     *    |   New Frame  |  Has Message |  Length of segment (excluding the header)              |</span></div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;<span class="comment">     *    +--------------+--------------+--------------------------------------------------------+</span></div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="comment">     * The header is encoded in big-endian (msb first) style.</span></div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="comment">     * Consider the following calls to create a frame:</span></div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;<span class="comment">     *    ncpBuffer.InFrameBegin();</span></div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;<span class="comment">     *    ncpBuffer.InFrameFeedData(&quot;Hello&quot;, 5);</span></div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;<span class="comment">     *    ncpBuffer.InFrameFeedData(&quot;There&quot;, 5);</span></div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;<span class="comment">     *    ncpBuffer.InFrameFeedMessage(*someMessage);</span></div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;<span class="comment">     *    ncpBuffer.InFrameFeedData(&quot;Bye&quot;, 3);</span></div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;<span class="comment">     *    ncpBuffer.InFrameEnd();</span></div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;<span class="comment">     * This frame is stored as two segments:</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="comment">     *    - Segment #1 contains &quot;HelloThere&quot; with a header of `0xC00A` which shows that this segment contains 10 data</span></div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;<span class="comment">     *      bytes, and it starts a new frame, and also must include a message from the message queue.</span></div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;<span class="comment">     *    - Segment #2 contains &quot;Bye&quot; with a header value of `0x0003` showing length of 3 and no appended message.</span></div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;<span class="comment">     *    +-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+</span></div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;<span class="comment">     *    | C0  | 0A  | `H` | &#39;e&#39; | &#39;l&#39; | &#39;l&#39; | &#39;o&#39; | &#39;T&#39; | &#39;h&#39; | &#39;e&#39; | &#39;r&#39; | &#39;e&#39; | 00  | 03  | &#39;B&#39; | &#39;y&#39; | &#39;e&#39; |</span></div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;<span class="comment">     *    +-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+</span></div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;<span class="comment">     *     \         /                                                             \         /</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="comment">     *   Segment #1 Header                                                      Segment #2 Header</span></div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="comment">     */</span></div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    {</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        kReadByteAfterFrameHasEnded        = 0,          <span class="comment">// Value returned by ReadByte() when frame has ended.</span></div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        kMessageReadBufferSize             = 16,         <span class="comment">// Size of message buffer array.</span></div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        kUnknownFrameLength                = 0xffff,     <span class="comment">// Value used when frame length is unknown.</span></div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        kSegmentHeaderSize                 = 2,          <span class="comment">// Length of the segment header.</span></div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        kSegmentHeaderLengthMask           = 0x3fff,     <span class="comment">// Bit mask to get the length from the segment header</span></div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        kSegmentHeaderNoFlag               = 0,          <span class="comment">// No flags are set.</span></div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        kSegmentHeaderNewFrameFlag         = (1 &lt;&lt; 15),  <span class="comment">// Indicates that this segment starts a new frame.</span></div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        kSegmentHeaderMessageIndicatorFlag = (1 &lt;&lt; 14),  <span class="comment">// Indicates this segment ends with a Message.</span></div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    };</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    <span class="keyword">enum</span> ReadState</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    {</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        kReadStateInSegment,        <span class="comment">// In middle of a data segment while reading current (out) frame.</span></div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        kReadStateInMessage,        <span class="comment">// In middle of a message while reading current (out) frame.</span></div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;        kReadStateDone,             <span class="comment">// Current (out) frame is read fully.</span></div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;    };</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    <span class="comment">// Private methods</span></div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    uint8_t *       Next(uint8_t *aBufferPtr) <span class="keyword">const</span>;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    uint8_t *       Advance(uint8_t *aBufPtr, uint8_t aOffset) <span class="keyword">const</span>;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    uint16_t        GetDistance(uint8_t *aStartPtr, uint8_t *aEndPtr) <span class="keyword">const</span>;</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    uint16_t        ReadUint16At(uint8_t *aBufPtr);</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    <span class="keywordtype">void</span>            WriteUint16At(uint8_t *aBufPtr, uint16_t aValue);</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>     InFrameFeedByte(uint8_t aByte);</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>     InFrameBeginSegment(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    <span class="keywordtype">void</span>            InFrameEndSegment(uint16_t aSegmentHeaderFlags);</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    <span class="keywordtype">void</span>            InFrameDiscard(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>     OutFramePrepareSegment(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    <span class="keywordtype">void</span>            OutFrameMoveToNextSegment(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>     OutFramePrepareMessage(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>     OutFrameFillMessageBuffer(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    <span class="comment">// Instance variables</span></div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    uint8_t * <span class="keyword">const</span> mBuffer;                    <span class="comment">// Pointer to the buffer used to store the data.</span></div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    uint8_t * <span class="keyword">const</span> mBufferEnd;                 <span class="comment">// Points to after the end of buffer.</span></div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    <span class="keyword">const</span> uint16_t  mBufferLength;              <span class="comment">// Length of the the buffer.</span></div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a>  mEmptyBufferCallback;       <span class="comment">// Callback to signal when buffer becomes empty.</span></div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    <a class="code" href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">BufferCallback</a>  mNonEmtyBufferCallback;     <span class="comment">// Callback to signal when buffer becomes non-empty.</span></div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;    <span class="keywordtype">void</span> *          mCallbackContext;           <span class="comment">// Context passed to callbacks.</span></div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;    <a class="code" href="../../da/d1a/classThread_1_1MessageQueue.html">MessageQueue</a>    mMessageQueue;              <span class="comment">// Main message queue.</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;    <a class="code" href="../../da/d1a/classThread_1_1MessageQueue.html">MessageQueue</a>    mWriteFrameMessageQueue;    <span class="comment">// Message queue for the current frame being written.</span></div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;    uint8_t *       mWriteFrameStart;           <span class="comment">// Pointer to start of current frame being written.</span></div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    uint8_t *       mWriteSegmentHead;          <span class="comment">// Pointer to start of current segment in the frame being written.</span></div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    uint8_t *       mWriteSegmentTail;          <span class="comment">// Pointer to end of current segment in the frame being written.</span></div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    ReadState       mReadState;                 <span class="comment">// Read state.</span></div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    uint16_t        mReadFrameLength;           <span class="comment">// Length of current frame being read.</span></div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    uint8_t *       mReadFrameStart;            <span class="comment">// Pointer to start of current frame being read.</span></div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    uint8_t *       mReadSegmentHead;           <span class="comment">// Pointer to start of current segment in the frame being read.</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;    uint8_t *       mReadSegmentTail;           <span class="comment">// Pointer to end of current segment in the frame being read.</span></div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    uint8_t *       mReadPointer;               <span class="comment">// Pointer to next byte to read (either in segment or in msg buffer).</span></div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    <a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> *       mReadMessage;               <span class="comment">// Current Message in the frame being read.</span></div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    uint16_t        mReadMessageOffset;         <span class="comment">// Offset within current message being read.</span></div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    uint8_t         mMessageBuffer[kMessageReadBufferSize];   <span class="comment">// Buffer to hold part of current message being read.</span></div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    uint8_t *       mReadMessageTail;           <span class="comment">// Pointer to end of current part in mMessageBuffer.</span></div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;};</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;<span class="preprocessor">#endif  // NCP_FRAME_BUFFER_HPP_</span></div><div class="ttc" id="classThread_1_1Message_html"><div class="ttname"><a href="../../dc/d3c/classThread_1_1Message.html">Thread::Message</a></div><div class="ttdoc">This class represents a message. </div><div class="ttdef"><b>Definition:</b> message.hpp:213</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_a46d59d1e7c71eff0d4cf9ea91b821ead"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a46d59d1e7c71eff0d4cf9ea91b821ead">Thread::NcpFrameBuffer::InFrameEnd</a></div><div class="ttdeci">ThreadError InFrameEnd(void)</div><div class="ttdoc">This method finalizes/ends the current input frame being written to the buffer. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:298</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_af7e6c123cca21c4ea9459c2a3ca350b6"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af7e6c123cca21c4ea9459c2a3ca350b6">Thread::NcpFrameBuffer::OutFrameBegin</a></div><div class="ttdeci">ThreadError OutFrameBegin(void)</div><div class="ttdoc">This method begins/prepares a new output frame to be read from the frame buffer. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:450</div></div>
<div class="ttc" id="openthread-types_8h_html_ab701d053a9c34ab7f11e43e0dc09ac9f"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a></div><div class="ttdeci">ThreadError</div><div class="ttdoc">This enumeration represents error codes used throughout OpenThread. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:75</div></div>
<div class="ttc" id="classThread_1_1MessageQueue_html"><div class="ttname"><a href="../../da/d1a/classThread_1_1MessageQueue.html">Thread::MessageQueue</a></div><div class="ttdoc">This class implements a message queue. </div><div class="ttdef"><b>Definition:</b> message.hpp:626</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_a69de51cb5b7132fa7d82270f3090f4dc"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a69de51cb5b7132fa7d82270f3090f4dc">Thread::NcpFrameBuffer::SetCallbacks</a></div><div class="ttdeci">void SetCallbacks(BufferCallback aEmptyBufferCallback, BufferCallback aNonEmptyBufferCallback, void *aContext)</div><div class="ttdoc">This method sets the callbacks and context. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:99</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_a4062341057541242068c5680c35f5a1c"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a4062341057541242068c5680c35f5a1c">Thread::NcpFrameBuffer::OutFrameRead</a></div><div class="ttdeci">uint16_t OutFrameRead(uint16_t aReadLength, uint8_t *aDataBuffer)</div><div class="ttdoc">This method reads bytes from the current output frame. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:529</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_a34a6141ff650ec07602b246fe3e65404"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a34a6141ff650ec07602b246fe3e65404">Thread::NcpFrameBuffer::IsEmpty</a></div><div class="ttdeci">bool IsEmpty(void) const </div><div class="ttdoc">This method checks if the buffer is empty. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:328</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_ab8a97ac52ae66b96155e6fb72cbd7e38"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab8a97ac52ae66b96155e6fb72cbd7e38">Thread::NcpFrameBuffer::OutFrameRemove</a></div><div class="ttdeci">ThreadError OutFrameRemove(void)</div><div class="ttdoc">This method removes the current/front output frame from the buffer. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:541</div></div>
<div class="ttc" id="message_8hpp_html"><div class="ttname"><a href="../../d5/d8c/message_8hpp.html">message.hpp</a></div><div class="ttdoc">This file includes definitions for the message buffer pool and message buffers. </div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html">Thread::NcpFrameBuffer</a></div><div class="ttdef"><b>Definition:</b> ncp_buffer.hpp:41</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_ad20ceecdfd9130815f4f59a9192afeeb"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ad20ceecdfd9130815f4f59a9192afeeb">Thread::NcpFrameBuffer::NcpFrameBuffer</a></div><div class="ttdeci">NcpFrameBuffer(uint8_t *aBuffer, uint16_t aBufferLength)</div><div class="ttdoc">This constructor creates an NCP frame buffer. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:38</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_abf94a643cd4931c947e4682c6fa21a64"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#abf94a643cd4931c947e4682c6fa21a64">Thread::NcpFrameBuffer::OutFrameHasEnded</a></div><div class="ttdeci">bool OutFrameHasEnded(void)</div><div class="ttdoc">This method checks if the current output frame (being read) has ended. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:465</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_a0ee345fdaf05d9e00da8a2f9bf628824"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a0ee345fdaf05d9e00da8a2f9bf628824">Thread::NcpFrameBuffer::BufferCallback</a></div><div class="ttdeci">void(* BufferCallback)(void *aContext, NcpFrameBuffer *aNcpFrameBuffer)</div><div class="ttdoc">Defines a function pointer callback which is invoked to inform state transition of buffer...</div><div class="ttdef"><b>Definition:</b> ncp_buffer.hpp:52</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_af5fa8d69618ffb232ea0693f5622e948"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af5fa8d69618ffb232ea0693f5622e948">Thread::NcpFrameBuffer::InFrameFeedMessage</a></div><div class="ttdeci">ThreadError InFrameFeedMessage(Message &amp;aMessage)</div><div class="ttdoc">This method adds a message to the current input frame being written to the buffer. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:281</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_a5f8aef01dd5f6b673c2a16a7e0aece29"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a5f8aef01dd5f6b673c2a16a7e0aece29">Thread::NcpFrameBuffer::InFrameBegin</a></div><div class="ttdeci">ThreadError InFrameBegin(void)</div><div class="ttdoc">This method begins a new input frame to be added/written to the frame buffer. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:256</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_a3987c8813a4aa3f7874b920736390e97"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a3987c8813a4aa3f7874b920736390e97">Thread::NcpFrameBuffer::InFrameFeedData</a></div><div class="ttdeci">ThreadError InFrameFeedData(const uint8_t *aDataBuffer, uint16_t aDataBufferLength)</div><div class="ttdoc">This method adds data to the current input frame being written to the buffer. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:264</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_ae80bc3d36fafc2a41b13270f7ffe54c2"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ae80bc3d36fafc2a41b13270f7ffe54c2">Thread::NcpFrameBuffer::~NcpFrameBuffer</a></div><div class="ttdeci">~NcpFrameBuffer()</div><div class="ttdoc">This destructor clears the NCP frame buffer and clears all frames. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:47</div></div>
<div class="ttc" id="openthread-types_8h_html"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a></div><div class="ttdoc">This file defines the types and structures used in the OpenThread library API. </div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_a8b7c96ec541408d307edf2c069ef208c"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#a8b7c96ec541408d307edf2c069ef208c">Thread::NcpFrameBuffer::OutFrameGetLength</a></div><div class="ttdeci">uint16_t OutFrameGetLength(void)</div><div class="ttdoc">This method returns the number of bytes (length) of current/front frame in the NCP frame buffer...</div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:602</div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_af8004f00f97e629cf5c5b0c6d695fcdc"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#af8004f00f97e629cf5c5b0c6d695fcdc">Thread::NcpFrameBuffer::OutFrameReadByte</a></div><div class="ttdeci">uint8_t OutFrameReadByte(void)</div><div class="ttdoc">This method reads and returns the next byte from the current output frame. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:470</div></div>
<div class="ttc" id="classThread_1_1NcpFrameBuffer_html_ab2380a440712abb615835172a0863bdf"><div class="ttname"><a href="../../d0/d78/classThread_1_1NcpFrameBuffer.html#ab2380a440712abb615835172a0863bdf">Thread::NcpFrameBuffer::Clear</a></div><div class="ttdeci">void Clear(void)</div><div class="ttdoc">This method clears the NCP frame buffer. </div><div class="ttdef"><b>Definition:</b> ncp_buffer.cpp:53</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_4eeddf84fddd42d44de1574042fba5c7.html">ncp</a></li><li class="navelem"><a class="el" href="../../d6/d92/ncp__buffer_8hpp.html">ncp_buffer.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:34 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
